# Contribution

Office UI Fabric React is an evolving snapshot of the Office 365 Design Language's components, built with [React](https://facebook.github.io/react/).

Right now, the project is in a **pre-v1** state, so we're mainly driving torwards the goals outlined in the [roadmap](https://github.com/OfficeDev/office-ui-fabric-react/blob/master/ghdocs/ROADMAP.md). With this in mind, feel free to file bugs but new components or additional features will probably not be considered to be executed on until after the v1 state is reached.

### Contribution license agreement
For pull requests affecting fewer than 15 lines of code, you will need to sign a [Contribution License Agreement (CLA)](https://cla.microsoft.com/) before your contribution can be incorporated. To complete the CLA, you will need to submit the request via the form and then electronically sign the CLA when you receive the email containing the link to the document.

This needs to only be done once for any Microsoft open source project.

### Issue tracker labels

We track community issues via GitHub's [issue tracker](https://github.com/OfficeDev/Office-UI-Fabric-react/issues). To help us keep track of the different areas, please use the following labels:

- `accessibility` - Issues or PRs that pertain to keyboard support, high contrast mode, screen reader support, etc.
- `bug` - Issues or PRs that address unexpected behavior or broken components.
- `build-system` - Issues and PRs related to the build process.
- `documentation` - Issues and PRs that pertain to the documentation included with the repository.
- `enhancement` - Issues or PRs that address potential improvements to components.
- `feature-request` - Issues or PRs that address ask for or add a major piece of functionality.
- `needs-design` - Issues or PRs that need Design guidance.
- `needs-discussion` - Issues or PRs that need discussion among the Fabric team.
- `question` - Issues that don't necessarily require code and usually consist of clarifications.
- `waiting-for-author` - Issues or PRs that are awaiting a repsonse from the original author.
- `waiting-for-details` - Issues or PRs that need more details before they can be acted upon.
- `waiting-to-merge` - PRs that are close to being merged in but are stalled.
